Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.nwoods.jgo.svg
Class DefaultDocument

    java.lang.Object
      com.nwoods.jgo.svg.DefaultDocument

All Implemented Interfaces:
  DomDoc

public class DefaultDocument
extends java.lang.Object
implements DomDoc

A wrapper class for org.w3c.dom.Document. By implementing the interface DomDocument, this class allows the com.nwoods.jgo package to provide methods that manipulate org.w3c.dom.Document objects while not requiring the org.w3c.dom.Document class to be present in order to build com.nwoods.jgo. JGo applications that support serialization to and from SVG XML files require this class.

Constructor Summary
`DefaultDocument()` Create a new DefaultDocument

Method Summary
`void` | `buildJGoDoc(JGoDocument jGoDoc)` Build a JGoDocument document from this DefaultDocument.
`void` | `buildSVGDoc(JGoDocument jGoDoc)` Build a DefaultDocument from this JGoDocument.
`DomCDATASection` | `createCDATASection(java.lang.String s)`
`DomElement` | `createElement(java.lang.String s)` Creates an DomElement of the type specified.
`DomElement` | `createJGoClassElement(java.lang.String className, DomElement parent)` Creates an JGoClass DomElement.
`DomText` | `createText(java.lang.String s)` Creates a DomText node given the specified string.
`protected void` | `GenerateTooltipInitialization(DomElement parent)`
`protected void` | `GenerateTooltipScript(DomElement parent)`
`org.w3c.dom.Document` | `getDocument()` Return the org.w3c.dom.Document associated with this DefaultDocument.
`DomElement` | `getDocumentElement()` This is a convenience attribute that allows direct access to the child DomElement that is the root element of the document.
`double` | `getJGoSVGVersion()` Return the JGo SVG version number associated with this document.
`org.w3c.dom.Node` | `importNode(org.w3c.dom.Node importedNode, boolean deep)` Imports a node from another document to this document.
`DomNode` | `initializeObjectFromXML(JGoDocument jGoDoc, DomElement element, DomElement jGoChildElement, java.lang.Object obj)` Initialize the JGoClass element that has been read from the XML file and instantiated.
`boolean` | `isDisabledDrawing()` Determines if output of SVG visible elements by superclass is currently disabled
`boolean` | `isGenerateJGoXML()` Determines if output of JGo XML extensions to SVG is enabled.
`boolean` | `isGenerateSVG()` Determines if output of any SVG elements to the generated XML is enabled.
`boolean` | `isReadSVG()`
`boolean` | `isRegisteredReference(java.lang.Object obj)` Determines whether a reference to a particular object has already been regigistered by registerReferencingNode().
`boolean` | `isSVGTooltips()` Dermines if SVG tooltips along with associated tooltip scripts should be generated.
`boolean` | `JGoXMLOutputEnabled()` Compute whether the output of JGo XML extensions is currently allowed.
`void` | `registerObject(java.lang.Object obj, DomElement node)` Register the DomElement associated with an Object.
`void` | `registerReferencingNode(DomElement referencingNode, java.lang.String refName, java.lang.Object referencedObj)` Register the attribute name and referenced Object associated with a referencing DomElement.
`void` | `registerReferencingObject(java.lang.Object obj, java.lang.String attr, java.lang.String refTag)` Register the attribute name and referenced identifier associated with a referencing Object.
`void` | `registerTag(java.lang.String tag, java.lang.Object obj)` Register the Object associated with a DomElement id attribute.
`protected void` | `RenderTooltip(DomElement parent)`
`void` | `resetDocument()` Create a new empty document for reading or writing SVG XML.
`void` | `setDisabledDrawing(boolean disable)` Disable the output of any visible SVG elements by superclass.
`void` | `setGenerateJGoXML(boolean enable)` Enable the output of JGo XML extensions to SVG.
`void` | `setGenerateSVG(boolean enable)` Enable the output of SVG elements to the generated XML.
`void` | `setReadSVG(boolean enable)`
`void` | `setSVGTooltips(boolean enable)` Enable the generation of SVG tooltips along with associated tooltip scripts.
`boolean` | `SVGOutputEnabled()` Compute whether the output of SVG elements is currently allowed.
`void` | `SVGReadDoc(java.io.InputStream ins, JGoDocument jGoDoc)` Read an SVG XML document into the specified JGoDocument.
`void` | `SVGReadDoc(java.io.Reader inr, JGoDocument jGoDoc)` Read an SVG XML document into the specified JGoDocument.
`DomNode` | `SVGReadElement(JGoDocument jGoDoc, java.lang.String sTag, DomElement element, java.lang.String sFirstChildTag, DomElement jGoChildElement, JGoArea parent, boolean addToDoc)` Read a DomElement, create an object to represent the DomElement and call SVGReadObject() on that object.
`void` | `SVGTraverseChildren(JGoDocument jGoDoc, DomNode svgNode, JGoArea parent, boolean addToDoc)` Traverse the DomNode children of a DomNode.
`void` | `SVGWriteDoc(java.io.OutputStream outs, JGoDocument jGoDoc)` Write an SVG XML document representing this JGoDocument.
`void` | `SVGWriteDoc(java.io.Writer outw, JGoDocument jGoDoc)` Write an SVG XML document representing this JGoDocument.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DefaultDocument

    public DefaultDocument()

  Create a new DefaultDocument

Method Detail

### resetDocument

    public void resetDocument()

  Create a new empty document for reading or writing SVG XML.

### createElement

    public DomElement createElement(java.lang.String s)

  Description copied from interface: `DomDoc`
  Creates an DomElement of the type specified.

  Specified by:
    `createElement` in interface `DomDoc`
  Parameters:
    `s` - the name of the element type to instantiate.
  Returns:
    the created DomElement
  See Also:
    `SVGWriteDoc(java.io.OutputStream, com.nwoods.jgo.JGoDocument)`, `com.nwoods.jgo`

### createText

    public DomText createText(java.lang.String s)

  Description copied from interface: `DomDoc`
  Creates a DomText node given the specified string.

  Specified by:
    `createText` in interface `DomDoc`
  Parameters:
    `s` - data for the new DomText node.
  Returns:
    the created DomText
  See Also:
    `SVGWriteDoc(java.io.OutputStream, com.nwoods.jgo.JGoDocument)`, `com.nwoods.jgo`

### createCDATASection

    public DomCDATASection createCDATASection(java.lang.String s)

  Specified by:
    `createCDATASection` in interface `DomDoc`

### getDocumentElement

    public DomElement getDocumentElement()

  This is a convenience attribute that allows direct access to the child DomElement that is the root element of the document.

  Returns:
    the root DomElement of the DefaultDocument

### registerObject

    public void registerObject(java.lang.Object obj,
                               DomElement node)

  Description copied from interface: `DomDoc`
  Register the DomElement associated with an Object. This method will be called for any JGoObject whenever JGoObject.SVGWriteObject() is called. Subclasses of JGoObject need not directly call this method. This registration occurs so that the DomElements associated with a referenced JGoObject can be easily found and updated to include an "id" attribute when writing out an SVG XML document.

  Specified by:
    `registerObject` in interface `DomDoc`
  Parameters:
    `obj` - the object to register in the map.
    `node` - the DomElement associated with the obj
  See Also:
    `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `DomDoc.registerReferencingNode(com.nwoods.jgo.DomElement, java.lang.String, java.lang.Object)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`

### registerReferencingNode

    public void registerReferencingNode(DomElement referencingNode,
                                        java.lang.String refName,
                                        java.lang.Object referencedObj)

  Description copied from interface: `DomDoc`
  Register the attribute name and referenced Object associated with a referencing DomElement. Call this from JGoObject.SVGWriteObject() to register a reference to another Object whose DomElement may not yet have been created during the process of writing an SVG XML document using com.nwoods.jgo.svg.DefaultDocument.SVGWriteDoc(). After all DomElements have been created, all referencing DomElements will be updated to include referencing attribute of the form "jgoid#" and the JGoClass DomElement for all referenced DomElements will be update to include a referenced attribute of the form "id=jgoid#", where # is a unique number.

  Specified by:
    `registerReferencingNode` in interface `DomDoc`
  Parameters:
    `referencingNode` - the DomElement containing a reference to another DomElement.
    `refName` - the name of the reference attribute in the referencing DomElement.
    `referencedObj` - the referenced Object
  See Also:
    `SVGWriteDoc(java.io.OutputStream, com.nwoods.jgo.JGoDocument)`, `com.nwoods.jgo`

### isRegisteredReference

    public boolean isRegisteredReference(java.lang.Object obj)

  Description copied from interface: `DomDoc`
  Determines whether a reference to a particular object has already been regigistered by registerReferencingNode(). This is often useful to know if the first reference to an object should cause a DomElement representing that object to be genereated and subsquent references to that object should only reference the previously generated element.

  Specified by:
    `isRegisteredReference` in interface `DomDoc`
  Returns:
    true if the referenced Object has
  See Also:
    `SVGWriteDoc(java.io.OutputStream, com.nwoods.jgo.JGoDocument)`, `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `DomDoc.registerReferencingNode(com.nwoods.jgo.DomElement, java.lang.String, java.lang.Object)`

### registerTag

    public void registerTag(java.lang.String tag,
                            java.lang.Object obj)

  Description copied from interface: `DomDoc`
  Register the Object associated with a DomElement id attribute. This method will be called for any JGoObject whenever JGoObject.SVGReadObject() is called. Subclasses of JGoObject need not directly call this method. This registration occurs so that the JGoObjects associated with a referenced DomElement can be easily found, enabling JGoObject.SVGUpdateReference() to be called on the referencing object passing the referenced JGoObject when reading in an SVG XML document.

  Specified by:
    `registerTag` in interface `DomDoc`
  Parameters:
    `tag` - the id attribute to be used as a key value for lookups
    `obj` - the object associated with this tag id value
  See Also:
    `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`

### registerReferencingObject

    public void registerReferencingObject(java.lang.Object obj,
                                          java.lang.String attr,
                                          java.lang.String refTag)

  Description copied from interface: `DomDoc`
  Register the attribute name and referenced identifier associated with a referencing Object. Call this from JGoObject.SVGReadObject() to register a reference to another Object which may not yet have been created during the process of reading an SVG XML document using com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc(). After all Objects have been created, SVGUpdateReference() will be called for all Objects registered by this method, passing in the attribute name of the reference and the referenced object.

  Specified by:
    `registerReferencingObject` in interface `DomDoc`
  Parameters:
    `obj` - the Object containing a reference to another Object described by a DomElement.
    `attr` - the name of the reference attribute in the referencing DomElement.
    `refTag` - the unique identifier of the referenced Object as specified in the referencing DomElement.
  See Also:
    `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `com.nwoods.jgo`, `com.nwoods.jgo`

### SVGWriteDoc

    public void SVGWriteDoc(java.io.OutputStream outs,
                            JGoDocument jGoDoc)

  Write an SVG XML document representing this JGoDocument.

  This method will create a Scalable Vector Graphics (SVG) XML representation of the indicated JGoDocument. For every JGoObject contained in the the JGoDocument, JGoObject.SVGWriteObject() will be called to output an appropriate SVG representation of that object. If you have created subclasses of JGoObjects containing data that you would like to save in the SVG representation, you should override SVGWriteObject() to add this information. Refer to JGoObject.SVGWriteObject() for more details. Documents written by this method may be read by SVGReadDoc().

  Parameters:
    `outs` - the OutputStream to which the document will be written
    `jGoDoc` - the JGoDocument to be output as SVG XML
  See Also:
    `SVGWriteDoc(Writer, JGoDocument)`, `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGWriteDoc

    public void SVGWriteDoc(java.io.Writer outw,
                            JGoDocument jGoDoc)

  Write an SVG XML document representing this JGoDocument.

  This method will create a Scalable Vector Graphics (SVG) XML representation of the indicated JGoDocument. For every JGoObject contained in the the JGoDocument, JGoObject.SVGWriteObject() will be called to output an appropriate SVG representation of that object. If you have created subclasses of JGoObjects containing data that you would like to save in the SVG representation, you should override SVGWriteObject() to add this information. Refer to JGoObject.SVGWriteObject() for more details. Documents written by this method may be read by SVGReadDoc().

  Parameters:
    `outw` - the Writer to which the document will be written
    `jGoDoc` - the JGoDocument to be output as SVG XML
  See Also:
    `SVGWriteDoc(OutputStream, JGoDocument)`, `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGReadDoc

    public void SVGReadDoc(java.io.InputStream ins,
                           JGoDocument jGoDoc)
                    throws java.lang.Exception

  Read an SVG XML document into the specified JGoDocument.

  This method will read a Scalable Vector Graphics (SVG) XML representation writen by SVGWriteDoc() into indicated JGoDocument. This method will call JGoObject.SVGReadObject() for every <JGoClass> element encountered in a DomDoc. First, an object of the type specified by the class attribute will be created and then the SVGReadObject() method will be called on that newly created object. Refer to SVGWriteObject() for a description of the expected format of the SVG document.

  This method may also be called to read any SVG document, including those not generated by JGo and therefore not containing any <JGoClass> elements. In such cases, the DefaultDocument.SVGReadElement() method may be subclassed to examine the SVG element and cause the appropriate JGoObject to be created to represent that element and call SVGReadObject() on that newly created object. By default, standard JGoObjects such as JGoRectangles, JGoStrokes, etc will be created to represent these objects.

  Parameters:
    `ins` - the InputStream from which the document will be read
    `jGoDoc` - the JGoDocument to be populated from the SVG XML document
  Throws:
    `java.lang.Exception`
  See Also:
    `SVGReadDoc(Reader, JGoDocument)`, `SVGWriteDoc(java.io.OutputStream, com.nwoods.jgo.JGoDocument)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGReadDoc

    public void SVGReadDoc(java.io.Reader inr,
                           JGoDocument jGoDoc)
                    throws java.lang.Exception

  Read an SVG XML document into the specified JGoDocument.

  This method will read a Scalable Vector Graphics (SVG) XML representation writen by SVGWriteDoc() into indicated JGoDocument. This method will call JGoObject.SVGReadObject() for every <JGoClass> element encountered in a DomDoc. First, an object of the type specified by the class attribute will be created and then the SVGReadObject() method will be called on that newly created object. Refer to SVGWriteObject() for a description of the expected format of the SVG document.

  This method may also be called to read any SVG document, including those not generated by JGo and therefore not containing any <JGoClass> elements. In such cases, the DefaultDocument.SVGReadElement() method may be subclassed to examine the SVG element and cause the appropriate JGoObject to be created to represent that element and call SVGReadObject() on that newly created object. By default, standard JGoObjects such as JGoRectangles, JGoStrokes, etc will be created to represent these objects.

  Parameters:
    `inr` - the Reader from which the document will be read
    `jGoDoc` - the JGoDocument to be populated from the SVG XML document
  Throws:
    `java.lang.Exception`
  See Also:
    `SVGReadDoc(InputStream, JGoDocument)`, `SVGWriteDoc(java.io.OutputStream, com.nwoods.jgo.JGoDocument)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### buildSVGDoc

    public void buildSVGDoc(JGoDocument jGoDoc)

  Build a DefaultDocument from this JGoDocument.

  This is typically called prior to writing out a DefaultDocument by calling writeFile(). See the implementation of SVGWriteDoc() for typical use of this method.

  Parameters:
    `jGoDoc` - the JGoDocument from which to populate this DefaultDocument.

### buildJGoDoc

    public void buildJGoDoc(JGoDocument jGoDoc)

  Build a JGoDocument document from this DefaultDocument.

  This is typically called after reading in an extended SVG representation to the DefaultDocument by calling readFile(). See the implementation of SVGReadDoc() for typical use of this method.

  Parameters:
    `jGoDoc` - the JGoDocument to be populated from this DefaultDocument

### SVGTraverseChildren

    public void SVGTraverseChildren(JGoDocument jGoDoc,
                                    DomNode svgNode,
                                    JGoArea parent,
                                    boolean addToDoc)

  Description copied from interface: `DomDoc`
  Traverse the DomNode children of a DomNode. This method will traverse the DomElement children of an DomNode and call SVGReadElement() on them which will in turn automatically create an appropriate JGoObject and call JGoObject.SVGReadObject() for all JGoClass DomNodes representing JGoObjects.

  Specified by:
    `SVGTraverseChildren` in interface `DomDoc`
  Parameters:
    `jGoDoc` - the JGoDocument being populated from the SVG XML document
    `svgNode` - the DomNode whose children are to be traversed
    `parent` - the JGoArea to which child objects should be added, or null
    `addToDoc` - a flag indicating whether objects should be added to the JGoDocument
  See Also:
    `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `SVGReadElement(com.nwoods.jgo.JGoDocument, java.lang.String, com.nwoods.jgo.DomElement, java.lang.String, com.nwoods.jgo.DomElement, com.nwoods.jgo.JGoArea, boolean)`, `com.nwoods.jgo`

### SVGReadElement

    public DomNode SVGReadElement(JGoDocument jGoDoc,
                                  java.lang.String sTag,
                                  DomElement element,
                                  java.lang.String sFirstChildTag,
                                  DomElement jGoChildElement,
                                  JGoArea parent,
                                  boolean addToDoc)

  Read a DomElement, create an object to represent the DomElement and call SVGReadObject() on that object.

  This method recognized JGoClass DomElements and automatically creates Objects of the class specified by the class attribute. If the newly created Object is a JGoObject it will automatically call SVGReadObject() on that object.

  In order to handle DomElements which are not JGoClass elements or to handle JGoClass elements where the class attribute identifies a class which is not a subclass of JGoObject, the SVGReadElement() method may be subclassed to examine the SVG element and cause the appropriate JGoObject to be created to represent that element and call SVGReadObject() on that newly created object. By default, standard SVG elements such as <line> and <rect> are handled by creating similar JGoObjects such as JGoRectangles, JGoStrokes, etc. to represent these objects.

  For convenience, because the DomElements representing a JGoObject are surrounded by a <g> element, the arguments passed to this method identify not only the DomElement beging read, but also the first child DomElement which represents the most specific subclass of the JGoObject to be created.

  Parameters:
    `jGoDoc` - the JGoDocument being populated from the SVG XML document
    `sTag` - the tag of the DomElement being read
    `element` - the DomElement being read
    `sFirstChildTag` - the tag of the first DomElement child of the DomElement being read
    `parent` - the JGoArea to which child objects should be added, or null
    `addToDoc` - a flag indicating whether objects should be added to the JGoDocument
  See Also:
    `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `com.nwoods.jgo`

### initializeObjectFromXML

    public DomNode initializeObjectFromXML(JGoDocument jGoDoc,
                                           DomElement element,
                                           DomElement jGoChildElement,
                                           java.lang.Object obj)

  Initialize the JGoClass element that has been read from the XML file and instantiated. Typically, this involves calling SVGReadObject() on the newly instanitated object.

  Parameters:
    `jGoDoc` - the JGoDocument being populated from the SVG XML document
    `element` - the DomElement being read
    `jGoChildElement` - the current <JGoClass> element being read withing the <g>
    `obj` - the newly instatiated Object specified by the JGoClass element
  See Also:
    `SVGReadDoc(java.io.InputStream, com.nwoods.jgo.JGoDocument)`, `com.nwoods.jgo`

### createJGoClassElement

    public DomElement createJGoClassElement(java.lang.String className,
                                            DomElement parent)

  Description copied from interface: `DomDoc`
  Creates an JGoClass DomElement.

  Create a JGoClass DomElement with the specified className value for the class attribute and append it as the next child node of the specified parent. Note that the className supplied must be accurate and complete as it will be used to create an object of the correct type when the SVG XML file is read.

  Specified by:
    `createJGoClassElement` in interface `DomDoc`
  Parameters:
    `className` - the class name JGoObject this JGoClass DomElement represents
    `parent` - the parent <g> to which to append the newly created DomElement that contains the definition of this JGoObject
  Returns:
    the created DomElement
  See Also:
    `SVGWriteDoc(java.io.OutputStream, com.nwoods.jgo.JGoDocument)`, `com.nwoods.jgo`

### setDisabledDrawing

    public void setDisabledDrawing(boolean disable)

  Description copied from interface: `DomDoc`
  Disable the output of any visible SVG elements by superclass. This method is typically called by SVGWriteObject() in order to disable any SVG drawing operations by a JGoObject superclass. By default, superclasses of an JGoObject are allowed to add visible SVG elements to the output DomDoc. For example, any user subclass of a JGoRectangle will appear in the SVG output as a rectangle. However, it some circumstances a subclass will want to control all aspects of the SVG drawing and will want to disable any visible SVG output from being generated by the superclasses. For example, a JGoPolygon is a subclass of JGoStroke. JGoStroke segments are drawn using a <line> element while a closed JGoPolygon is drawn using a <path> element. Thus, JGoPolygon uses setDisabledDrawing() to avoid the erroneous <line> elements from being generated by its superclass. Note that SVGWriteDoc() will automatically reenable SVG drawing before calling JGoObject.SVGWriteObject() on the next JGoObject instance encountered in the JGoDocument.

  Specified by:
    `setDisabledDrawing` in interface `DomDoc`
  Parameters:
    `disable` - true if SVG output of visible elements is to be disabled

### isDisabledDrawing

    public boolean isDisabledDrawing()

  Description copied from interface: `DomDoc`
  Determines if output of SVG visible elements by superclass is currently disabled

  Specified by:
    `isDisabledDrawing` in interface `DomDoc`
  Returns:
    true of SVG output of visible element is currently disabled
  See Also:
    `DomDoc.setDisabledDrawing(boolean)`

### getJGoSVGVersion

    public double getJGoSVGVersion()

  Description copied from interface: `DomDoc`
  Return the JGo SVG version number associated with this document. The version number is stored as in the jgosvgversion attribute of the svg element in any extended SVG document written by JGo. This version number is used by Northwoods to track changes to the extended SVG document structure and should not be modified by users. Users wishing to track the version number of their own extensions to the JGo extended SVG should create and use a separate attribute for this purpose.

  Specified by:
    `getJGoSVGVersion` in interface `DomDoc`
  Returns:
    the JGo SVG version number associated with this document.

### setGenerateJGoXML

    public void setGenerateJGoXML(boolean enable)

  Description copied from interface: `DomDoc`
  Enable the output of JGo XML extensions to SVG.

  Specified by:
    `setGenerateJGoXML` in interface `DomDoc`
  Parameters:
    `enable` - true if JGo XML extensions to SVG are to be disabled

### isGenerateJGoXML

    public boolean isGenerateJGoXML()

  Description copied from interface: `DomDoc`
  Determines if output of JGo XML extensions to SVG is enabled.

  Specified by:
    `isGenerateJGoXML` in interface `DomDoc`
  Returns:
    true of SVG output of visible element is currently disabled
  See Also:
    `DomDoc.setDisabledDrawing(boolean)`

### setGenerateSVG

    public void setGenerateSVG(boolean enable)

  Description copied from interface: `DomDoc`
  Enable the output of SVG elements to the generated XML.

  Specified by:
    `setGenerateSVG` in interface `DomDoc`
  Parameters:
    `enable` - true if the output of any SVG elements to the generated XML is to be enabled

### isGenerateSVG

    public boolean isGenerateSVG()

  Description copied from interface: `DomDoc`
  Determines if output of any SVG elements to the generated XML is enabled.

  Specified by:
    `isGenerateSVG` in interface `DomDoc`
  Returns:
    true if the output of any SVG elements to the generated XML is enabled
  See Also:
    `DomDoc.setDisabledDrawing(boolean)`

### setReadSVG

    public void setReadSVG(boolean enable)

### isReadSVG

    public boolean isReadSVG()

### setSVGTooltips

    public void setSVGTooltips(boolean enable)

  Description copied from interface: `DomDoc`
  Enable the generation of SVG tooltips along with associated tooltip scripts. By default, SVG tooltips are generated as elements and displayed using scripts. <P> <DD><DL> <DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html#setSVGTooltips(boolean)">setSVGTooltips</A></CODE> in interface <CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html" title="interface in com.nwoods.jgo">DomDoc</A></CODE></DL> </DD> <DD><DL> <DT><B>Returns:</B><DD>true if SVG tooltips should be generated</DL> </DD> </DL> <HR> <A NAME="isSVGTooltips()"><!-- --></A><H3> isSVGTooltips</H3> <PRE> public boolean <B>isSVGTooltips</B>()</PRE> <DL> <DD><B>Description copied from interface: <CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html" title="interface in com.nwoods.jgo">DomDoc</A></CODE></B></DD> <DD>Dermines if SVG tooltips along with associated tooltip scripts should be generated. By default, SVG tooltips are generated as <title> elements and displayed using scripts. <P> <DD><DL> <DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html#isSVGTooltips()">isSVGTooltips</A></CODE> in interface <CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html" title="interface in com.nwoods.jgo">DomDoc</A></CODE></DL> </DD> <DD><DL> <DT><B>Returns:</B><DD>true if the generation of SVG tooltips is to be enabled</DL> </DD> </DL> <HR> <A NAME="SVGOutputEnabled()"><!-- --></A><H3> SVGOutputEnabled</H3> <PRE> public boolean <B>SVGOutputEnabled</B>()</PRE> <DL> <DD><B>Description copied from interface: <CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html" title="interface in com.nwoods.jgo">DomDoc</A></CODE></B></DD> <DD>Compute whether the output of SVG elements is currently allowed. <P> <DD><DL> <DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html#SVGOutputEnabled()">SVGOutputEnabled</A></CODE> in interface <CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html" title="interface in com.nwoods.jgo">DomDoc</A></CODE></DL> </DD> <DD><DL> <DT><B>Returns:</B><DD>true if the output of SVG elements is currently allowed.</DL> </DD> </DL> <HR> <A NAME="JGoXMLOutputEnabled()"><!-- --></A><H3> JGoXMLOutputEnabled</H3> <PRE> public boolean <B>JGoXMLOutputEnabled</B>()</PRE> <DL> <DD><B>Description copied from interface: <CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html" title="interface in com.nwoods.jgo">DomDoc</A></CODE></B></DD> <DD>Compute whether the output of JGo XML extensions is currently allowed. <P> <DD><DL> <DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html#JGoXMLOutputEnabled()">JGoXMLOutputEnabled</A></CODE> in interface <CODE><A HREF="../../../../com/nwoods/jgo/DomDoc.html" title="interface in com.nwoods.jgo">DomDoc</A></CODE></DL> </DD> <DD><DL> <DT><B>Returns:</B><DD>true if the output of JGo XML extensions is currently allowed.</DL> </DD> </DL> <HR> <A NAME="importNode(org.w3c.dom.Node, boolean)"><!-- --></A><H3> importNode</H3> <PRE> public org.w3c.dom.Node <B>importNode</B>(org.w3c.dom.Node importedNode, boolean deep) throws org.w3c.dom.DOMException</PRE> <DL> <DD>Imports a node from another document to this document. The returned node has no parent; (parentNode is null). The source node is not altered or removed from the original document; this method creates a new copy of the source node. Refer to org.w3c.dom.Document.importNode() for more details on this method. <P> <DD><DL> </DL> </DD> <DD><DL> <DT><B>Parameters:</B><DD><CODE>importedNode</CODE> - node to import.<DD><CODE>deep</CODE> - If true, recursively import the subtree under the specified node; if false, import only the node itself. <DT><B>Throws:</B> <DD><CODE>org.w3c.dom.DOMException</CODE></DL> </DD> </DL> <HR> <A NAME="getDocument()"><!-- --></A><H3> getDocument</H3> <PRE> public org.w3c.dom.Document <B>getDocument</B>()</PRE> <DL> <DD>Return the org.w3c.dom.Document associated with this DefaultDocument. <P> <DD><DL> </DL> </DD> <DD><DL> <DT><B>Returns:</B><DD>the the org.w3c.dom.Document associated with this DefaultDocument</DL> </DD> </DL> <HR> <A NAME="GenerateTooltipInitialization(com.nwoods.jgo.DomElement)"><!-- --></A><H3> GenerateTooltipInitialization</H3> <PRE> protected void <B>GenerateTooltipInitialization</B>(<A HREF="../../../../com/nwoods/jgo/DomElement.html" title="interface in com.nwoods.jgo">DomElement</A> parent)</PRE> <DL> <DD><DL> </DL> </DD> <DD><DL> </DL> </DD> </DL> <HR> <A NAME="RenderTooltip(com.nwoods.jgo.DomElement)"><!-- --></A><H3> RenderTooltip</H3> <PRE> protected void <B>RenderTooltip</B>(<A HREF="../../../../com/nwoods/jgo/DomElement.html" title="interface in com.nwoods.jgo">DomElement</A> parent)</PRE> <DL> <DD><DL> </DL> </DD> <DD><DL> </DL> </DD> </DL> <HR> <A NAME="GenerateTooltipScript(com.nwoods.jgo.DomElement)"><!-- --></A><H3> GenerateTooltipScript</H3> <PRE> protected void <B>GenerateTooltipScript</B>(<A HREF="../../../../com/nwoods/jgo/DomElement.html" title="interface in com.nwoods.jgo">DomElement</A> parent)</PRE> <DL> <DD><DL> </DL> </DD> <DD><DL> </DL> </DD> </DL> <!-- ========= END OF CLASS DATA ========= --> <HR> <!-- ======= START OF BOTTOM NAVBAR ====== --> <A NAME="navbar_bottom"><!-- --></A> <A HREF="#skip-navbar_bottom" title="Skip navigation links"></A> <TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY=""> <TR> <TD COLSPAN=3 BGCOLOR="#EEEEFF" CLASS="NavBarCell1"> <A NAME="navbar_bottom_firstrow"><!-- --></A> <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY=""> <TR ALIGN="center" VALIGN="top"> <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1"> <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A> </TD> <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1"> <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A> </TD> <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> <FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT> </TD> <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1"> <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A> </TD> <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1"> <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A> </TD> <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1"> <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A> </TD> <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1"> <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A> </TD> </TR> </TABLE> </TD> <TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM> </EM> </TD> </TR> <TR> <TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2"> <A HREF="../../../../com/nwoods/jgo/svg/DefaultCDATASection.html" title="class in com.nwoods.jgo.svg"><B>PREV CLASS</B></A> <A HREF="../../../../com/nwoods/jgo/svg/DefaultElement.html" title="class in com.nwoods.jgo.svg"><B>NEXT CLASS</B></A></FONT></TD> <TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2"> <A HREF="../../../../index.html" target="_top"><B>FRAMES</B></A> <A HREF="DefaultDocument.html" target="_top"><B>NO FRAMES</B></A> <SCRIPT type="text/javascript"> <!-- if(window==top) { document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>'); } //--> </SCRIPT> <NOSCRIPT> <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A> </NOSCRIPT> </FONT></TD> </TR> <TR> <TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2"> SUMMARY: NESTED | FIELD | <A HREF="#constructor_summary">CONSTR</A> | <A HREF="#method_summary">METHOD</A></FONT></TD> <TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2"> DETAIL: FIELD | <A HREF="#constructor_detail">CONSTR</A> | <A HREF="#method_detail">METHOD</A></FONT></TD> </TR> </TABLE> <A NAME="skip-navbar_bottom"></A> <!-- ======== END OF BOTTOM NAVBAR ======= --> <HR> </BODY> </HTML>